# bett.py

from grafikfenster import *
from math import radians
from moebel import Moebel

### ---------------------------------------------------
class Bett(Moebel):
    """Klasse Bett
    ermoeglicht das Zeichnen und Bearbeiten eines
    Bett-Symbols fuer den Raumplaner"""
    
    def __init__(self,
                 xPos=20,
                 yPos=20,
                 breite=200,
                 tiefe=200,
                 winkel=0,
                 farbe="black",
                 fuellfarbe=None,
                 sichtbar=False):
        """Konstruktor mit vordefinierten Parametern
        Konstruktor der Oberklasse aufrufen!"""
        Moebel.__init__(self, xPos, yPos, breite, tiefe, winkel, farbe, fuellfarbe, sichtbar)
        if sichtbar: self.Zeige()
        
    def GibFigur(self):
        """definiert die zu zeichnende Figur"""
        path = self.GibZeichenPfad()

        # lokale Variable zur Schreibvereinfachung
        b, t = self.GibBreite(), self.GibTiefe()
        ##path.AddRectangle(0, 0, b, t)
        # Das Bett bekommt nur innere Teilfiguren.
        path1 = self.GibZeichenPfad()
        path1.MoveToPoint(0, 0)
        path1.AddLineToPoint(b, 0)
        path1.AddLineToPoint(0, t/2)
        path1.CloseSubpath()
        path.AddPath(path1)
        ###
        path2 = self.GibZeichenPfad()
        path2.MoveToPoint(0, t/2)
        path2.AddLineToPoint(b, 0)
        path2.AddLineToPoint(b, t/2)
        path2.CloseSubpath()
        path.AddPath(path2)
        ###
        path3 = self.GibZeichenPfad()
        path3.MoveToPoint(0, t/2)
        path3.AddLineToPoint(b, t/2)
        path3.AddLineToPoint(b, t)
        path3.CloseSubpath()
        path.AddPath(path3)
        ###
        path4 = self.GibZeichenPfad()
        path4.MoveToPoint(0, t/2)
        path4.AddLineToPoint(b, t)
        path4.AddLineToPoint(0, t)
        path4.CloseSubpath()
        path.AddPath(path4)

        return self.Transformiere(path)


### ---------------------------------------------------
class BettApp(wx.App):
    """Test-Anwendung speziell fuer Bett"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global bett
        bett=Bett(10, 140, winkel=90, farbe="green",fuellfarbe="yellow", sichtbar=True)
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = BettApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
