# sofa.py

from grafikfenster import *
from math import radians
from moebel import Moebel

### ---------------------------------------------------
class Sofa(Moebel):
    """Klasse Sofa
    ermoeglicht das Zeichnen und Bearbeiten eines
    Sofa-Symbols fuer den Raumplaner"""
    
    def __init__(self,
                 xPos=40,
                 yPos=30,
                 breite=140,
                 tiefe=60,
                 winkel=0,
                 farbe="brown",
                 fuellfarbe=None,
                 sichtbar=False):
        """Konstruktor mit vordefinierten Parametern
        Konstruktor der Oberklasse aufrufen!"""
        Moebel.__init__(self, xPos, yPos, breite, tiefe, winkel, farbe, fuellfarbe, sichtbar)
        if sichtbar: self.Zeige()
        
    def GibFigur(self):
        """definiert die zu zeichnende Figur"""
        path = self.GibZeichenPfad()

        # lokale Variable zur Schreibvereinfachung
        b, t = self.GibBreite(), self.GibTiefe()

        ## Lehnen
        path1 = self.GibZeichenPfad()
        path1.MoveToPoint(0,0)
        path1.AddLineToPoint(b,0)
        path1.AddLineToPoint(b,t)
        path1.AddLineToPoint(b-b/12,t)
        path1.AddLineToPoint(b-b/12,t/6)
        path1.AddLineToPoint(b/12,t/6)
        path1.AddLineToPoint(b/12,t)
        path1.AddLineToPoint(0,t)
        path1.CloseSubpath()
        path.AddPath(path1)
        ## Sitzfläche 1
        path2 = self.GibZeichenPfad()
        path2.AddRectangle(b/12, t/6, 5*b/12, 5*t/6)
        path.AddPath(path2)        
        ## Sitzfläche 2
        path3 = self.GibZeichenPfad()
        path3.AddRectangle(b/2, t/6, 5*b/12, 5*t/6)
        path.AddPath(path3)
        
        return self.Transformiere(path)


### ---------------------------------------------------
class SofaApp(wx.App):
    """Test-Anwendung speziell fuer Sofa"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global sofa
        sofa=Sofa(fuellfarbe='LIGHT GRAY',sichtbar=True)
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = SofaApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
